=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2012-01-24 16:19:04 +0000
+++ bzrlib/merge.py	2012-02-17 15:57:53 +0000
@@ -1105,8 +1105,8 @@
         # 'other_tree.inventory.root' is not present in this tree. We are
         # calling adjust_path for children which *want* to be present with a
         # correct place to go.
-        for _, child in self.other_tree.inventory.root.children.iteritems():
-            trans_id = self.tt.trans_id_file_id(child.file_id)
+        for child_id in self.other_tree.iter_children(self.other_tree.get_root_id()):
+            trans_id = self.tt.trans_id_file_id(child_id)
             if not other_root_is_present:
                 if self.tt.final_kind(trans_id) is not None:
                     # The item exist in the final tree and has a defined place

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2012-01-24 17:18:38 +0000
+++ bzrlib/tree.py	2012-02-17 15:57:53 +0000
@@ -532,13 +532,16 @@
         return find_ids_across_trees(paths, [self] + list(trees), require_versioned)
 
     def iter_children(self, file_id):
-        entry = self.iter_entries_by_dir([file_id]).next()[1]
-        for child in getattr(entry, 'children', {}).itervalues():
-            yield child.file_id
+        """Iterate over the file ids of the children of an entry.
+
+        :param file_id: File id of the entry
+        :return: Iterator over child file ids.
+        """
+        raise NotImplementedError(self.iter_children)
 
     def lock_read(self):
         """Lock this tree for multiple read only operations.
-        
+
         :return: A bzrlib.lock.LogicalLockResult.
         """
         pass
@@ -872,6 +875,12 @@
     def get_file_by_path(self, path):
         return self.get_file(self.path2id(path), path)
 
+    def iter_children(self, file_id, path=None):
+        """See Tree.iter_children."""
+        entry = self.iter_entries_by_dir([file_id]).next()[1]
+        for child in getattr(entry, 'children', {}).itervalues():
+            yield child.file_id
+
 
 def find_ids_across_trees(filenames, trees, require_versioned=True):
     """Find the ids corresponding to specified filenames.
@@ -1335,7 +1344,7 @@
                         if old_entry is None:
                             # Reusing a discarded change.
                             old_entry = self._get_entry(self.source, file_id)
-                        for child in old_entry.children.values():
+                        for child in self.source.iter_children(file_id):
                             precise_file_ids.add(child.file_id)
                     changed_file_ids.add(result[0])
                     yield result

